using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ECcomm
{
    public partial class EC : Form
    {

        #region Winmate WinIO DLL Declare

        [DllImport(@"WMIO2.dll")]
        public static extern bool ModeOpen(uint uiMode);

        [DllImport(@"WMIO2.dll")]
        public static extern bool ModeClose();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetDevice(byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetDevice(out byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetDevice2(byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetDevice2(out byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetBrightness(byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetBrightness(out byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetSMBIOSInfo(string name, byte[] data);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetFileVersion(byte[] data);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetProductVersion(byte[] data);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetFlashOn();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetFlashOff();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetFlash2On();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetFlash2Off();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetAutoScreenRotationLock(uint uiMode);

        [DllImport(@"WMIO2.dll")]
        public static extern uint SetSoftwareHotSwap();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetLightSensorOnOff(uint uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetProximitySensorOnOff(uint uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetLightSensorChannel0(out uint uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetLightSensorChannel1(out uint uiValue);

        #endregion

        public EC()
        {
            InitializeComponent();
        }

        private void btnUnlock_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            ModeOpen(0);
            string strOK = "Unlock KBC";
            listBox1.Items.Add(strOK);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void btnLockKBC_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            ModeClose();
            string strOK = "Lock KBC";
            listBox1.Items.Add(strOK);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            textBox1.Clear();
        }
    
        private void EC_Load(object sender, EventArgs e)
        {
            textBox1.Focus();
        }

        private void btnFocus_Click(object sender, EventArgs e)
        {
            textBox1.Focus();
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            int ch;
            ch = Convert.ToInt32(e.KeyChar);
            string strkey = "Pressed:   (0x" + ch.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {
            string strkey = "UP   : " + Convert.ToString(e.KeyCode).ToString();
            strkey = strkey + "      ; (" + e.KeyValue.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            string strkey = "Down : " + Convert.ToString(e.KeyCode).ToString();
            strkey = strkey + " ; (" + e.KeyValue.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            bool ret;

            ret = SetBrightness((byte)numericUpDown1.Value);
            if (!ret)
                MessageBox.Show("SetBrightness Error");
        }

        private void DevSetBtn_Click(object sender, EventArgs e)
        {
            SetDevice();
        }

        private void DevGetBtn_Click(object sender, EventArgs e)
        {
            GetDevice();
        }


        private void tabPage3_Click(object sender, EventArgs e)
        {
            GetDevice();
        }

        private void tabPage3_Enter(object sender, EventArgs e)
        {
            GetDevice();
        }

        private void GetDevice()
        {
            bool ret;
            byte Value;

            ret = GetDevice(out Value);
            if (!ret)
                MessageBox.Show("GetDevice1 Error");
            else
            {
                if ((Value & 0x80) == 0x80)
                    DevBit7Chk.Checked = true;
                else
                    DevBit7Chk.Checked = false;

                if ((Value & 0x40) == 0x40)
                    DevBit6Chk.Checked = true;
                else
                    DevBit6Chk.Checked = false;

                if ((Value & 0x20) == 0x20)
                    DevBit5Chk.Checked = true;
                else
                    DevBit5Chk.Checked = false;

                if ((Value & 0x10) == 0x10)
                    DevBit4Chk.Checked = true;
                else
                    DevBit4Chk.Checked = false;

                if ((Value & 0x08) == 0x08)
                    DevBit3Chk.Checked = true;
                else
                    DevBit3Chk.Checked = false;

                if ((Value & 0x04) == 0x04)
                    DevBit2Chk.Checked = true;
                else
                    DevBit2Chk.Checked = false;

                if ((Value & 0x02) == 0x02)
                    DevBit1Chk.Checked = true;
                else
                    DevBit1Chk.Checked = false;

                if ((Value & 0x01) == 0x01)
                    DevBit0Chk.Checked = true;
                else
                    DevBit0Chk.Checked = false;
            }
        }

        private void SetDevice()
        {
            byte setvalue = 0;
            bool ret;


            if (DevBit0Chk.Checked)
                setvalue += 0x01;

            if (DevBit1Chk.Checked)
                setvalue += 0x02;

            if (DevBit2Chk.Checked)
                setvalue += 0x04;

            if (DevBit3Chk.Checked)
                setvalue += 0x08;

            if (DevBit4Chk.Checked)
                setvalue += 0x10;

            if (DevBit5Chk.Checked)
                setvalue += 0x20;

            if (DevBit6Chk.Checked)
                setvalue += 0x40;

            if (DevBit7Chk.Checked)
                setvalue += 0x80;


            ret = SetDevice(setvalue);
            if (!ret)
            {
                GetDevice();
                MessageBox.Show("SetDevice1 Error");
            }
        }


        private void GetDevice2()
        {
            bool ret;
            byte Value;

            ret = GetDevice2(out Value);
            if (!ret)
                MessageBox.Show("GetDevice2 Error");
            else
            {
                if ((Value & 0x80) == 0x80)
                    Dev2Bit7Chk.Checked = true;
                else
                    Dev2Bit7Chk.Checked = false;

                if ((Value & 0x40) == 0x40)
                    Dev2Bit6Chk.Checked = true;
                else
                    Dev2Bit6Chk.Checked = false;

                if ((Value & 0x20) == 0x20)
                    Dev2Bit5Chk.Checked = true;
                else
                    Dev2Bit5Chk.Checked = false;

                if ((Value & 0x10) == 0x10)
                    Dev2Bit4Chk.Checked = true;
                else
                    Dev2Bit4Chk.Checked = false;

                if ((Value & 0x08) == 0x08)
                    Dev2Bit3Chk.Checked = true;
                else
                    Dev2Bit3Chk.Checked = false;

                if ((Value & 0x04) == 0x04)
                    Dev2Bit2Chk.Checked = true;
                else
                    Dev2Bit2Chk.Checked = false;

                if ((Value & 0x02) == 0x02)
                    Dev2Bit1Chk.Checked = true;
                else
                    Dev2Bit1Chk.Checked = false;

                if ((Value & 0x01) == 0x01)
                    Dev2Bit0Chk.Checked = true;
                else
                    Dev2Bit0Chk.Checked = false;
            }
        }

        private void SetDevice2()
        {
            byte setvalue = 0;
            bool ret;


            if (Dev2Bit0Chk.Checked)
                setvalue += 0x01;

            if (Dev2Bit1Chk.Checked)
                setvalue += 0x02;

            if (Dev2Bit2Chk.Checked)
                setvalue += 0x04;

            if (Dev2Bit3Chk.Checked)
                setvalue += 0x08;

            if (Dev2Bit4Chk.Checked)
                setvalue += 0x10;

            if (Dev2Bit5Chk.Checked)
                setvalue += 0x20;

            if (Dev2Bit6Chk.Checked)
                setvalue += 0x40;

            if (Dev2Bit7Chk.Checked)
                setvalue += 0x80;


            ret = SetDevice2(setvalue);
            if (!ret)
            {
                GetDevice2();
                MessageBox.Show("SetDevice2 Error");
            }
        }


        private int GetByteLen(byte[] array)
        {
            int i = 0;
            int len = 0;

            for (i = 0; i < array.Length; i++)
            {
                if (array[i] == 0)
                    return len;
                else
                    len++;

            }

            return len;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string ss = "";
            byte[] value = new byte[128];

            if (GetSMBIOSInfo("/IV", value))
                ss += "/IV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/ID", value))
                ss += "/ID = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SM", value))
                ss += "/SM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SP", value))
                ss += "/SP = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SV", value))
                ss += "/SV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SS", value))
                ss += "/SS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SU", value))
                ss += "/SU = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SK", value))
                ss += "/SK = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SF", value))
                ss += "/SF = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BM", value))
                ss += "/BM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BP", value))
                ss += "/BP = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BV", value))
                ss += "/BV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BS", value))
                ss += "/BS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BT", value))
                ss += "/BT = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CM", value))
                ss += "/CM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CT", value))
                ss += "/CT = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CV", value))
                ss += "/CV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CS", value))
                ss += "/CS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CA", value))
                ss += "/CA = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CO", value))
                ss += "/CO = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            MessageBox.Show(ss,"SMBios Information");
        }

        private void tabPage2_Enter(object sender, EventArgs e)
        {
            bool ret;
            byte Value;

            ret = GetBrightness(out Value);
            if (!ret)
                MessageBox.Show("GetBrightness Error");
            else
            {
                numericUpDown1.Value = Value;
            }
        }

        private void tabPage2_Click(object sender, EventArgs e)
        {
            bool ret;
            byte Value;

            ret = GetBrightness(out Value);
            if (!ret)
                MessageBox.Show("GetBrightness Error");
            else
            {
                numericUpDown1.Value = Value;
            }
        }

        private void Dev2SetBtn_Click(object sender, EventArgs e)
        {
            SetDevice2();
        }

        private void Dev2GetBtn_Click(object sender, EventArgs e)
        {
            GetDevice2();
        }

        private void tabPage5_Click(object sender, EventArgs e)
        {
            GetDevice2();
        }

        private void tabPage5_Enter(object sender, EventArgs e)
        {
            GetDevice2();
        }

        private void Flash1OnBtn_Click(object sender, EventArgs e)
        {
            SetFlashOn();
        }

        private void Flash1OffBtn_Click(object sender, EventArgs e)
        {
            SetFlashOff();
        }

        private void Flash2OnBtn_Click(object sender, EventArgs e)
        {
            SetFlash2On();
        }

        private void Flash2OffBtn_Click(object sender, EventArgs e)
        {
            SetFlash2Off();
        }

        private void RLockSetBtn_Click(object sender, EventArgs e)
        {
            SetAutoScreenRotationLock(1);
        }

        private void RUnLockSetBtn_Click(object sender, EventArgs e)
        {
            SetAutoScreenRotationLock(0);
        }

        private void BatHotSwapBtn_Click(object sender, EventArgs e)
        {
            uint uiRetValue;

            uiRetValue = SetSoftwareHotSwap();

            if ((uiRetValue & 0x80) == 0x80)
            {
                BatHotSwaplabel.Text = "status: fail!";
                BatHotSwapRetlabel.Text = "Ret: " + String.Format("0x{0:X}", Convert.ToByte(uiRetValue));
            }
            else
            {
                BatHotSwaplabel.Text = "status: success!";
                BatHotSwapRetlabel.Text = "Ret: " + String.Format("0x{0:X}", Convert.ToByte(uiRetValue));
            }

        }

        private void LightSensorEnBtn_Click(object sender, EventArgs e)
        {
            SetLightSensorOnOff(1);
        }

        private void LightSensorDisBtn_Click(object sender, EventArgs e)
        {
            SetLightSensorOnOff(0);
        }

        private void ProximitySensorEnBtn_Click(object sender, EventArgs e)
        {
            SetProximitySensorOnOff(1);
        }

        private void ProximitySensorDisBtn_Click(object sender, EventArgs e)
        {
            SetProximitySensorOnOff(0);
        }

        private void tabPage7_Enter(object sender, EventArgs e)
        {

        }

        private void LightSensorTimer_Tick(object sender, EventArgs e)
        {
            LightSensorTimer.Stop();

            bool ret=false;
            uint Value=0;

            ret = GetLightSensorChannel0(out Value);
            if (ret)
            {
                CH0TB.Text = Value.ToString();
            }

            ret = false;
            Value = 0;
            ret = GetLightSensorChannel1(out Value);
            if (ret)
            {
                CH1TB.Text = Value.ToString();
            }

            LightSensorTimer.Start();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            LightSensorTimer.Start();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            LightSensorTimer.Stop();
            CH0TB.Text = "";
            CH1TB.Text = "";
        }



    }
}